
function RMAInbox_OnLoad()
  RMAInbox:SetParent(InboxFrame);
  end

function RMAInbox_Hide()
  if (RMASmall:GetChecked() == 1 ) then 
    RMAInbox:ClearAllPoints();
    RMASmall:SetChecked(0);
    RMAInbox:SetPoint("TOPRIGHT",InboxFrame,"TOPRIGHT",-5,-12)
    sizeBtn:SetText(">")
 else 
    RMAInbox:ClearAllPoints();
    RMASmall:SetChecked(1);
    sizeBtn:SetText("<")
    RMAInbox:SetPoint("TOPRIGHT",InboxFrame,"TOPRIGHT",180,-12)
 end
end

function RMAInbox_ShowInboxInfo()
--RMA:DebugPrint("Printing inbox Info");
  chkCOD:SetChecked(0);
  chkCOD:Disable();
  local info = RMAMail_GetInboxInfo();
  local msg = "";
  SetLabelText("lblCount",info["messages"]);
      
  if(info["newMail"] == nil or info["newMail"] == 0) then
    SetLabelText("lblNew","0");
  else
    SetLabelText("lblNew",info["newCount"]);
  end
  
  SetLabelText("lblItems",info["items2"]);
   
  msg="<html><body><p>";
   
  if(info["gold"] > 0) then
    msg = msg .. info["gold"] .. " |Tinterface\\addons\\daemonmailassist\\textures\\gold:12:12:0:0|t";
  end if(info["silver"] > 0) then
    msg = msg .. info["silver"] .. " |Tinterface\\addons\\daemonmailassist\\textures\\silver:12:12:0:0|t";
  end if(info["copper"] > 0) then
    msg = msg .. info["copper"] .. " |Tinterface\\addons\\daemonmailassist\\textures\\copper:12:12:0:0|t";
  end

  if msg == "<html><body><p>" then msg = msg .. "None";   end
  

  msg = msg .. "</p></body></html>";
  htmlMoney:SetText(msg);
  
  
    if(info["cod"] == 0) then htmlCOD:Hide(); CoDLBL:Hide() else
    iG = (info["cod"] / 10000);
    iS = (iG - math.floor(iG)) * 100;
    iC = (iS - math.floor(iS)) * 100;
    iG = math.floor(iG);
    iS = math.floor(iS);
    iC = math.ceil(iC);
    msg = ""   
  if( iG > 0) then
    msg = msg .. iG .. " |Tinterface\\addons\\daemonmailassist\\textures\\gold:12:12:0:0|t";
  end if( iS > 0) then
    msg = msg .. iS .. " |Tinterface\\addons\\daemonmailassist\\textures\\silver:12:12:0:0|t";
  end if( iC > 0) then
    msg = msg .. iC .. " |Tinterface\\addons\\daemonmailassist\\textures\\copper:12:12:0:0|t";
  end

  chkCOD:Enable();
  htmlCOD:Show(); 
  htmlCOD:SetText(msg);
  CoDLBL:Show()
  end
  
  if(info["messages"] == nil or info["messages"] == 0) then
    btnGrab:Disable();
    chkItems:Disable();
    chkMoney:Disable();
    chkCOD:Disable();
  else
    btnGrab:Enable();
    chkItems:Enable();
    chkMoney:Enable();
    chkCOD:Enable();
  end
end

function RMAInbox_PopulateDropDown()

--RMA_LAST = ddlSenders.SelectedName

  local senders = RMAMail_GetSenders();

  if(senders == nil) then
    return;
  end

  local ddlSenders_init_fn = function()
    
    for i=-1, #senders do
      local entry = UIDropDownMenu_CreateInfo();
      if(i == -1) then
        entry.textHeight = 11;
        entry.text = "All";
        entry.value = "All";
        entry.func = function() 
                       ddlSenders.selectedName = "All";
                       ddlSenders.selectedID = i;
                       ddlSenders.selectedValue = "All";
                       ddlSendersText:SetText("All"); 
                         
                     end
        ddlSenders.selectedName = "All";
        ddlSenders.selectedID = i;
        ddlSenders.selectedValue = "All";
        ddlSendersText:SetText("All"); 
      else
        entry.textHeight = 11;
        entry.text = senders[i];
        entry.value = senders[i];
        entry.func = function()
           ddlSenders.selectedName = senders[i];
           ddlSenders.selectedID = i;
           ddlSenders.selectedValue = senders[i];
           ddlSendersText:SetText(senders[i]);
           end
      end
      
   
      
      UIDropDownMenu_AddButton(entry);
    end
  end
  UIDropDownMenu_Initialize(ddlSenders, ddlSenders_init_fn)
end



function RMAInbox_btnGrab_OnClick()
  local senderName = UIDropDownMenu_GetSelectedName(ddlSenders);
  local getMoney = false;
  local getItems = false;
  local payCOD = false;
  
  local iMoney = chkMoney:GetChecked();
  if(iMoney == nil) then
    getMoney = false;
  elseif(iMoney == 1) then
    getMoney = true;
  else
    getMoney = false;
  end
  
  local iCOD = chkCOD:GetChecked();
  if(iCOD == nil) then
    payCOD = false;
  elseif(iCOD == 1) then
    payCOD = true;
  else
    payCOD = false;
  end
    
  local iItems = chkItems:GetChecked();
  if(iItems == nil) then
    getItems = false;
  elseif(iItems == 1) then
    getItems = true;
  else
    getItems = false;
  end
  
  RMAMail_QueueGrabSender(senderName, getItems, getMoney, payCOD);
  RMAMail_StartProcessQueue();
end


function RMA_InboxUpdate()
	local numItems, totalItems = GetInboxNumItems();

    while numItems < #IndexBoxes do
		tremove(IndexBoxes, numItems + 1);
	end

    for t = #IndexBoxes + 1, numItems do
		IndexBoxes[t] = false;
	end
	
	local index = ((InboxFrame.pageNum - 1) * INBOXITEMS_TO_DISPLAY) + 1;
	
	for i=1, INBOXITEMS_TO_DISPLAY do
		if ( index <= numItems ) then
			getglobal("RMA_CheckButton"..i):SetChecked(IndexBoxes[index]);
			getglobal("RMA_CheckButton"..i):Show();
		else
			getglobal("RMA_CheckButton"..i):Hide();
		end
		
		index = index + 1;
	end
	
end

function RMA_ShowIndexBoxes()
	MailItem1:SetPoint("TOPLEFT", "InboxFrame", "TOPLEFT", 48, -80);

	for t = 1, INBOXITEMS_TO_DISPLAY do
		getglobal("MailItem"..t):SetWidth(280);
		getglobal("MailItem"..t.."Subject"):SetWidth(228);
		getglobal("MailItem"..t.."ExpireTime"):SetPoint("TOPRIGHT", "MailItem"..t, "TOPRIGHT", 10, -4);
		
		local frame;
		
		if (not getglobal("RMA_CheckButton"..t)) then
			frame = CreateFrame("CheckButton", "RMA_CheckButton"..t, getglobal("MailItem"..t), "RMA_CheckButtonTemplate");
			frame:SetPoint("TOPLEFT", "MailItem"..t, "TOPLEFT", -25, -9);
			frame:Hide();
		end
	end
end

function RMA_CheckButtonOnMouseUp(self)
    local index = gsub(self:GetName(), "RMA_CheckButton(%d+)", "%1");
	local button = getglobal("MailItem"..index.."Button");
	IndexBoxes[button.index] = not IndexBoxes[button.index];
end

function RMA_GetAll()
    RMA:DebugPrint("Firing Get All.")
    if (GetEverything) then
	RMA:DebugPrint("Already Getting All - Exiting.")
	return; 
    end
    
    HideUIPanel(OpenMailFrame);
    GetEverything = true;
    RMAMail_QueueGrabSender("All", true, true, false)
    RMAMail_StartProcessQueue();
end

